<script lang="ts">
  import ChallengeList from '@components/Sandbox/ChallengeList.svelte';
  import { onMount } from 'svelte';
  import { getBundles, getEnvironments, getPveConfig } from '@utils/SandboxApi';
  import type { Bundle, BundleCategory, Environment } from '@models/Sandbox';
  import type { OidcManager } from '@auth/keycloak';
  import { requireAuth } from '@auth/PermissionRequired';
  import { afterNavigate } from '$app/navigation';
  import { keycloak } from '@stores';
  import { BundleCategoryNames } from '@models/Sandbox.js';
  import type { PveConfig } from '@models/Sandbox';

  type PageData = {
    category: BundleCategory;
    keycloak: OidcManager;
  };

  /** @type {import('./$types').PageData} // Data from +page.ts */
  export let data: PageData;

  let bundles: Bundle[] = [];
  let environments: Environment[] = [];
  let category: BundleCategory;
  let pveConfig: PveConfig;

  let ready;

  // wait for authentication and all data to be loaded
  onMount(() => {
    ready = Promise.all([loadChallenges(data.category), getPveConfig().then((data) => (pveConfig = data))]);
  });
  afterNavigate(({ to }) => {
    loadChallenges((to?.params as PageData).category);
  });

  /**
   * Load Bundles and Environments for the current user
   * @param cat Category of Bundles to load
   */
  async function loadChallenges(cat): Promise<Awaited<any>> {
    console.debug('page category is', cat);
    category = cat; // save category for re-use in ChallengeList callback
    return Promise.all([
      getBundles({ category: cat, active: true }).then((data) => {
        bundles = data;
      }),
      getEnvironments({ owner: $keycloak.tokenParsed?.email }).then((data) => {
        environments = data;
      }),
    ]);
  }
</script>

<div class="justify-content-center mx-auto" use:requireAuth>
  <h1>{BundleCategoryNames[data.category]} Challenges</h1>
  {#await ready}
    <p>loading...</p>
  {:then ev}
    <ChallengeList {bundles} {environments} {pveConfig} updateChallenges={() => loadChallenges(category)} />
  {:catch e}
    <p>Failed to load challenges</p>
  {/await}
</div>
